#!/bin/sh

DESTDIR=munin-plugins-muninexchange-`date +%Y%m%d`
mkdir $DESTDIR
cd $DESTDIR

wget -nv http://muninexchange.projects.linpro.no/?search -O search

GROUPS=$(grep "option value=\"[1-9][0-9]*" search | \
	sed -e 's|<option value="\([1-9][0-9]*\)">\(.*\)</option>|\2:\1|g' | tr [A-Z] [a-z])

ppath=`pwd`
for g in $GROUPS ; do
	gid=$(echo $g | cut -f 2 -d ':')
	gn=$(echo $g | cut -f 1 -d ':')

	mkdir $gn
	cd $gn

	wget -nv "http://muninexchange.projects.linpro.no/?search&cid=$gid" -O $gn

	PLUGINS=$(awk 'BEGIN { start=0; }
		     /name="pid"/ { start=1 }
		     /<\/select>/ { start=0 }
		     start == 1 { print $0 }' $gn | grep "option value" | \
			sed -e 's|<option value="\([0-9]*\)">.*</option>|\1|g')

	for p in $PLUGINS ; do
		wget -nv "http://muninexchange.projects.linpro.no/?search&cid=$gid&pid=$p" -O plugin
		dnlid=$(grep "download.php?phid=" plugin | sed -e 's|.*"download.php?phid=\(.*\)".*|\1|')
		wget -nv --content-disposition http://muninexchange.projects.linpro.no/download.php?phid=$dnlid
	done
	rm -f $gn plugin
	
	# convert spaces to _ in file names
	for ff in * ; do
		mv -f "$ff" "`echo $ff | tr ' ' _`" 2>/dev/null
	done

	# remove junk
	JUNK=$(for i in * ; do file "$i" ; done | grep -v executable | cut -f1 -d':')
	[ -n "$JUNK" ] && rm -f $JUNK

	cd $ppath
	if [ "`echo $gn/*`" = "$gn/*" ] ; then
		rm -rf $gn
	fi
done

# those are present in munin
for ff in \
amavis \
cpuspeed \
hddtemp \
hddtemp_smartctl \
ipmi_ \
ircu \
multiping \
multips \
nfs4_client \
perdition \
postfix_mailstats \
postgres_block_read_ \
postgres_locks \
postgres_space_ \
processes \
sensors_ \
snmp__if_ \
snmp__netstat \
snmp__swap \
snmp__uptime \
uptime \
users
do
	rm -f */$ff
done

rm -f search

cd ..
cp getplugins.sh $DESTDIR

tar cjf $DESTDIR.tar.bz2 $DESTDIR
